您的位置:首页 > 编程语言 > C语言/C++

292. Nim Game

2016-07-13 12:09 183 查看

leetcode 292

Question: You are playing the following Nim Game with your friend: There is a heap of stones on the table, each time one of you take turns to remove 1 to 3 stones. The one who removes the last stone will be the winner. You will take the first turn to remove the stones.

Both of you are very clever and have optimal strategies for the game. Write a function to determine whether you can win the game given the number of stones in the heap.

For example, if there are 4 stones in the heap, then you will never win the game: no matter 1, 2, or 3 stones you remove, the last stone will always be removed by your friend.

class Solution {
public:
bool canWinNim(int n) {
return n % 4 != 0;
}
};


解题思路1

如果1<=n<=3,则先手赢;

如果n=4,则先手负;

如果5<=n<=7,先手可以在抓取一轮石子后转换成n=4的情况,则先手赢;

如果n=8,先手无论第一轮抓取多少颗石子都会将其转换成5<=n<=7的情况,故先手负。

解题思路2

因为每个人都取不到4个石子,假设自己后走,只要根据前一轮对方抓取的情况,保证两人在这两轮一共抓取了4个石子, 那么在最后两轮里剩下4个石子且是对方先抓取,则一定可以胜利。但是当前情况是自己先走,所以只要保证自己在第一轮抓取(n%4)个石子,就可以保证最后不管怎样都能剩余4个石子。故想要胜利,在第一轮一定有石子可以抓取,即n%4!=0。
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode C++